/***********************************************************************
  This file is part of HA, a general purpose file archiver.
  Copyright (C) 1995 Harri Hirvola

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
************************************************************************
	HA arithmetic coder
***********************************************************************/

#ifndef Included_acoder_h
#define Included_acoder_h

#include "ha.h"
#include "haio.h"


struct acoder
{
	U16B h,l,v;
	S16B s;
	S16B gpat,ppat;
};

struct acoder *ac_init_encode(struct haio *haio);
void ac_end_encode(struct acoder *ac, struct haio *haio);
struct acoder *ac_init_decode(struct haio *haio);
void ac_end_decode(struct acoder *ac, struct haio *haio);
void ac_out(struct acoder *ac, struct haio *haio, U16B low, U16B high, U16B tot);
U16B ac_threshold_val(struct acoder *ac, struct haio *haio, U16B tot);
void ac_in(struct acoder *ac, struct haio *haio, U16B low, U16B high, U16B tot);

#endif/* !Included_acoder_h */

