/***********************************************************************
  This file is part of HA, a general purpose file archiver.
  Copyright (C) 1995 Harri Hirvola

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
************************************************************************
       HA I/O routines
***********************************************************************/

#include <proto/exec.h>
#include "ha.h"
#include "haio.h"


struct haio *init_io(unsigned char *ibuf, U32B ilen, unsigned char *obuf, U32B olen)
{
	struct haio *haio;

	if (haio = (struct haio *)AllocVec(sizeof(struct haio),0))
	{
		haio->ibl=ilen;
		haio->ibf=0;
		haio->ib=ibuf;

		haio->obl=0;
		haio->obf=olen;
		haio->ob=obuf;
	}

	return haio;
}

U32B end_io(struct haio *haio)
{
	U32B len;

	len=haio->obl;

	FreeVec(haio);

	return len;
}

